import * as plugins from './spark.plugins.js';
import { SparkTaskManager } from './spark.classes.taskmanager.js';
import { SparkInfo } from './spark.classes.info.js';
import { SparkServicesManager } from './spark.classes.updatemanager.js';
import { logger } from './spark.logging.js';
import { SparkConfig } from './spark.classes.config.js';

export class Spark {
  public smartdaemon: plugins.smartdaemon.SmartDaemon;
  public sparkConfig: SparkConfig;
  public sparkTaskManager: SparkTaskManager;
  public sparkInfo: SparkInfo;
  public sparkUpdateManager: SparkServicesManager;

  constructor() {
    this.smartdaemon = new plugins.smartdaemon.SmartDaemon();
    this.sparkConfig = new SparkConfig(this);
    this.sparkInfo = new SparkInfo(this);
    this.sparkTaskManager = new SparkTaskManager(this);
    this.sparkUpdateManager = new SparkServicesManager(this);
  }

  public async daemonStart() {
    await this.sparkUpdateManager.start();
    this.sparkTaskManager.start();
  }
}
